package edu.berkeley.cs.cs162;

import java.util.Vector;

/**
   The GameServer manages all the running games and players. Any messages passed
   between players and games must go through the GameServer via the provided
   interface.
 */
public class GameServer implements Runnable {

    /**
       Creates and starts running a game with the specified game name, players,
       initial board configuration, and observers.
     */
    public void createGame(String gameName, Player blackPlayer, Player whitePlayer, Board initialBoard, int moveTimeoutInMs, Vector<Observer> initialObservers) {
	// TODO: implement me
    }
    
    /**
       @return The Game instance with the specified name.
     */
    private Game getGame(String gameName) {
	// TODO: implement me
	return null;
    }

    /**
       @return The Observer instance with the specified name.
     */
    private Observer getObserver(String observerName) {
	// TODO: implement me
	return null;
    }


    /**
       Methods to send information about game events to observers. Games may only notify
       their observers of game events by calling these methods.
     */
    
    public void sendGameStart(String targetObserverName, Game game, String blackPlayerName, String whitePlayerName, Board board, int moveTimeoutInMs) {
	getObserver(targetObserverName).handleGameStart(game.getName(), blackPlayerName, whitePlayerName, board, moveTimeoutInMs);
    }

    public void sendGameOver(String targetObserverName, Game game, double blackPlayerScore, double whitePlayerScore) {
	getObserver(targetObserverName).handleGameOver(game.getName(), blackPlayerScore, whitePlayerScore);
    }

    public void sendMakeMove(String targetObserverName, Game game, String playerName) {
	getObserver(targetObserverName).handleMakeMove(game.getName(), playerName);
    }

    public void sendStonePlaced(String targetObserverName, Game game, String playerName, Location loc, StoneColor color) {
	getObserver(targetObserverName).handleStonePlaced(game.getName(), playerName, loc, color);
    }

    public void sendStoneCaptured(String targetObserverName, Game game, String playerName, Location loc, StoneColor color) {
	getObserver(targetObserverName).handleStoneCaptured(game.getName(), playerName, loc, color);
    }

    public void sendPlayerPass(String targetObserverName, Game game, String playerName) {
	getObserver(targetObserverName).handlePlayerPass(game.getName(), playerName);
    }

    public void sendPlayerError(String targetObserverName, Game game, String playerName, String errorDescription) {
	getObserver(targetObserverName).handlePlayerError(game.getName(), playerName, errorDescription);
    }

    /**
       Methods for players to send move information to games. Players may only notify
       games of moves they want to make by calling these methods.
     */
    
    public void sendMoveToGame(Player player, String gameName, Location loc) {
	getGame(gameName).makeMove(player.getName(), loc);
    }

    public void sendPassMoveToGame(Player player, String gameName) {
	getGame(gameName).makePassMove(player.getName());
    }

    /**
       Blocks until all running games have finished.
     */
    public void waitForGames() {
	// TODO: implement me
    }

    public void run() {
	// TODO: implement me
    }
}
